// --------------------------------------------------------------------------------------
//
// FishFaceForms                                                   Ulrich Mller 12.08.07
//                                                                 PCS1700      VC++ 2005
//      Demo der Nutzung von FishFace2005.DLL durch VC++ 2005
//      Blinker an O1, Variante FishFace^ ft : ft->Open... 
//                    (FishFace ft : ft.Open.... geht auch)
//
// --------------------------------------------------------------------------------------

#pragma once

namespace FishFaceForms {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace FishFace40;

	/// <summary>
	/// Zusammenfassung fr Form1
	///
	/// Warnung: Wenn Sie den Namen dieser Klasse ndern, mssen Sie auch
	///          die Ressourcendateiname-Eigenschaft fr das Tool zur Kompilierung verwalteter Ressourcen ndern,
	///          das allen RESX-Dateien zugewiesen ist, von denen diese Klasse abhngt.
	///          Anderenfalls knnen die Designer nicht korrekt mit den lokalisierten Ressourcen
	///          arbeiten, die diesem Formular zugewiesen sind.
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form {
	  public:
			Form1(void)	{
				InitializeComponent();
			}

		protected:
			~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
		private: 
			FishFace^ ft;
			Button^  cmdAction;
			Button^  cmdEnde;
			Label^  lblStatus;
			System::ComponentModel::Container ^components;

#pragma region Windows Form Designer generated code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung.
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		void InitializeComponent(void)
		{
			this->cmdAction = (gcnew System::Windows::Forms::Button());
			this->cmdEnde = (gcnew System::Windows::Forms::Button());
			this->lblStatus = (gcnew System::Windows::Forms::Label());
			this->SuspendLayout();
			// 
			// cmdAction
			// 
			this->cmdAction->Location = System::Drawing::Point(167, 219);
			this->cmdAction->Name = L"cmdAction";
			this->cmdAction->Size = System::Drawing::Size(102, 32);
			this->cmdAction->TabIndex = 0;
			this->cmdAction->Text = L"START";
			this->cmdAction->UseVisualStyleBackColor = true;
			this->cmdAction->Click += gcnew System::EventHandler(this, &Form1::cmdAction_Click);
			// 
			// cmdEnde
			// 
			this->cmdEnde->DialogResult = System::Windows::Forms::DialogResult::Cancel;
			this->cmdEnde->Location = System::Drawing::Point(167, 169);
			this->cmdEnde->Name = L"cmdEnde";
			this->cmdEnde->Size = System::Drawing::Size(102, 32);
			this->cmdEnde->TabIndex = 1;
			this->cmdEnde->Text = L"Abbrechen";
			this->cmdEnde->UseVisualStyleBackColor = true;
			this->cmdEnde->Click += gcnew System::EventHandler(this, &Form1::cmdEnde_Click);
			// 
			// lblStatus
			// 
			this->lblStatus->BackColor = System::Drawing::SystemColors::ActiveCaptionText;
			this->lblStatus->Location = System::Drawing::Point(30, 47);
			this->lblStatus->Name = L"lblStatus";
			this->lblStatus->Size = System::Drawing::Size(238, 22);
			this->lblStatus->TabIndex = 2;
			this->lblStatus->Text = L"Interface kontrollieren : START";
			this->lblStatus->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			// 
			// Form1
			// 
			this->AcceptButton = this->cmdAction;
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->CancelButton = this->cmdEnde;
			this->ClientSize = System::Drawing::Size(292, 273);
			this->Controls->Add(this->lblStatus);
			this->Controls->Add(this->cmdEnde);
			this->Controls->Add(this->cmdAction);
			this->Name = L"Form1";
			this->Text = L"VC++ 2005 : FishFace2005.DLL Test";
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &Form1::Form1_FormClosing);
			this->ResumeLayout(false);

		}
#pragma endregion
		Void Form1_FormClosing(System::Object^  sender, 
			                     System::Windows::Forms::FormClosingEventArgs^  e) {
			if(!cmdAction->Enabled) e->Cancel = true;
		}
	Void cmdEnde_Click(System::Object^  sender, System::EventArgs^  e) {
		if(cmdAction->Enabled) this->Close(); else ft->NotHalt = true;
		}
	Void cmdAction_Click(System::Object^  sender, System::EventArgs^  e) {
		try {
			ft = gcnew FishFace;
			ft->OpenInterface(IFTypen::ftROBO_first_USB, 0);
			cmdAction->Enabled = false;
			lblStatus->Text = "Bei der Arbeit";
			cmdEnde->Text   = "HALT";
			Action();
			ft->ClearMotors();
			lblStatus->Text = "Auf ein Neues";
		}
		catch (FishFaceException^ e) {
			lblStatus->Text = e->Message;
		}
		ft->CloseInterface();
		cmdAction->Enabled = true;
		cmdEnde->Text = "ENDE";
	}
	Void Action() {
		while(!ft->Finish()) {
			ft->SetLamp(Out::O1, Dir::On);
			ft->Pause(333);
			ft->SetLamp(Out::O1, Dir::Off);
			ft->Pause(333);
		}
	}};}

